﻿using LEase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DemoWPF
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        
        LEaseMode easeMode;
        int iDuration;
        string stype;
        Storyboard sb;


        private void Slider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            lblTime.Content =Convert.ToInt32( e.NewValue);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            cboxType.Items.Add("Back");
            cboxType.Items.Add("Bounce");
            cboxType.Items.Add("Circle");
            cboxType.Items.Add("Quadratic");
            cboxType.Items.Add("Cubic");
            cboxType.Items.Add("Quartic");
            cboxType.Items.Add("Quintic");
            cboxType.Items.Add("Elastic");
            cboxType.Items.Add("Exponential");
            cboxType.Items.Add("Sine");

            cboxType.SelectedIndex = 0;
        }
        
        private void BtnShow_Click(object sender, RoutedEventArgs e)
        {
            #region 原版
            sb = new Storyboard();
            DoubleAnimationUsingKeyFrames ks = new DoubleAnimationUsingKeyFrames();

            EasingDoubleKeyFrame k1 = new EasingDoubleKeyFrame();
            k1.KeyTime = KeyTime.FromTimeSpan(TimeSpan.FromSeconds(0));
            k1.Value = 0;

            EasingMode easeMode2 = (bool)rbtnIn.IsChecked ? EasingMode.EaseIn : ((bool)rbtnOut.IsChecked ? EasingMode.EaseOut : EasingMode.EaseInOut);

            EasingDoubleKeyFrame k2 = new EasingDoubleKeyFrame();
            k2.KeyTime = KeyTime.FromTimeSpan(TimeSpan.FromSeconds(Convert.ToInt32(lblTime.Content)));
            k2.Value = 400;
            switch (cboxType.Text)
            {
                case "Back":
                    k2.EasingFunction = new BackEase() { EasingMode = easeMode2 };
                    break;
                case "Bounce":
                    k2.EasingFunction = new BounceEase() { EasingMode = easeMode2 };
                    break;
                case "Circle":
                    k2.EasingFunction = new CircleEase() { EasingMode = easeMode2 };
                    break;
                case "Quadratic":
                    k2.EasingFunction = new QuadraticEase() { EasingMode = easeMode2 };
                    break;
                case "Cubic":
                    k2.EasingFunction = new CubicEase() { EasingMode = easeMode2 };
                    break;
                case "Quartic":
                    k2.EasingFunction = new QuarticEase() { EasingMode = easeMode2 };
                    break;
                case "Quintic":
                    k2.EasingFunction = new QuinticEase() { EasingMode = easeMode2 };
                    break;
                case "Elastic":
                    k2.EasingFunction = new ElasticEase() { EasingMode = easeMode2 };
                    break;
                case "Exponential":
                    k2.EasingFunction = new ExponentialEase() { EasingMode = easeMode2 };
                    break;
                case "Sine":
                    k2.EasingFunction = new SineEase() { EasingMode = easeMode2 };
                    break;

            }

            ks.KeyFrames.Add(k1);
            ks.KeyFrames.Add(k2);
            sb.Children.Add(ks);
            Storyboard.SetTarget(ks, rect1);
            Storyboard.SetTargetProperty(ks, new PropertyPath("(Canvas.Left)"));

            sb.Completed += Sb_Completed;
            sb.Begin(rect1,true);
            #endregion

            #region 公式
            easeMode = (bool)rbtnIn.IsChecked ? LEaseMode.EaseIn : ((bool)rbtnOut.IsChecked ? LEaseMode.EaseOut : LEaseMode.EaseInOut);
            iDuration = Convert.ToInt32(Convert.ToInt32(lblTime.Content) * 1000);
            stype = cboxType.Text;
            var v = rect2.GetValue(Canvas.LeftProperty);
            new Thread(pTest).Start();
            #endregion


        }

        private void Sb_Completed(object sender, EventArgs e)
        {
            Thread.Sleep(1000);
            sb.Remove(rect1);
            Dispatcher.BeginInvoke(new Action<Label, double>(pSetLeft), rect2, 0d);
            //new Thread(pTest2).Start();
        }

        void pSetLeft(Label l,double d)
        {
            l.SetValue(Canvas.LeftProperty, d);
        }

        void pTest()
        {            
            int iInterval = 10;

            for (int i = 0; i <= iDuration; i += iInterval)
            {
                double d0 = 0;
                switch (stype)
                {
                    case "Back":
                        d0 = AnimateBase.Back(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Bounce":
                        d0 = AnimateBase.Bounce(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Circle":
                        d0 = AnimateBase.Circle(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Quadratic":
                        d0 = AnimateBase.Quadratic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Cubic":
                        d0 = AnimateBase.Cubic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Quartic":
                        d0 = AnimateBase.Quartic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Quintic":
                        d0 = AnimateBase.Quintic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Elastic":
                        d0 = AnimateBase.Elastic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Exponential":
                        d0 = AnimateBase.Exponential(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Sine":
                        d0 = AnimateBase.Sine(Convert.ToDouble(i) / iDuration, easeMode);
                        break;

                }

                double m =  d0 * 400;

                Dispatcher.BeginInvoke(new Action<Label, double>(pSetLeft), rect2, m);

                Thread.Sleep(iInterval);
            }

            Thread.Sleep(1000);
            Dispatcher.BeginInvoke(new Action<Label, double>(pSetLeft), rect2, 0d);

        }

        void pTest2()
        {
            Thread.Sleep(2000);
            sb.Remove(rect1);
            Dispatcher.BeginInvoke(new Action<Label, double>(pSetLeft), rect2, 0d);

        }

    }
}
