﻿using LEase;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DemoWinForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        int iStart, iEnd, iRange;
        Thread t;

        void pSetLeft(Control control, int left)
        {
            if (control.InvokeRequired)
            {
                control.Invoke(new Action<Control, int>(pSetLeft), new object[] { control, left });
            }
            else
            {
                control.Left = left;
            }
        }
                
        void pAnimate(object sAnimateName)
        {
            LEaseMode easeMode = radioButton1.Checked ? LEaseMode.EaseIn : (radioButton2.Checked ? LEaseMode.EaseOut : LEaseMode.EaseInOut);

            int iDuration = Convert.ToInt32(numericUpDown1.Value * 1000);
            int iInterval = 10;

            for (int i = 0; i <= iDuration; i += iInterval)
            {
                double d0=0;
                switch (sAnimateName)
                {
                    case "Back":
                        d0 = AnimateBase.Back(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Bounce":
                        d0 = AnimateBase.Bounce(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Circle":
                        d0 = AnimateBase.Circle(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Quadratic":
                        d0 = AnimateBase.Quadratic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Cubic":
                        d0 = AnimateBase.Cubic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Quartic":
                        d0 = AnimateBase.Quartic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Quintic":
                        d0 = AnimateBase.Quintic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Elastic":
                        d0 = AnimateBase.Elastic(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Exponential":
                        d0 = AnimateBase.Exponential(Convert.ToDouble(i) / iDuration, easeMode);
                        break;
                    case "Sine":
                        d0 = AnimateBase.Sine(Convert.ToDouble(i) / iDuration, easeMode);
                        break;

                }
                int m = iStart + Convert.ToInt16(d0 * iRange);
                pSetLeft(panel_Slider, m);

                Thread.Sleep(iInterval);
            }

            Thread.Sleep(2000);
            pSetLeft(panel_Slider, iStart);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (t != null)
                t.Abort();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            panel_Slider.Left = iStart;
            t = new Thread(new ParameterizedThreadStart(pAnimate));
            t.Start(comboBox1.Text);

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            iStart =70;
            iEnd = 470;
            iRange = iEnd - iStart;

            comboBox1.Items.Add("Back");
            comboBox1.Items.Add("Bounce");
            comboBox1.Items.Add("Circle");
            comboBox1.Items.Add("Quadratic");
            comboBox1.Items.Add("Cubic");
            comboBox1.Items.Add("Quartic");
            comboBox1.Items.Add("Quintic");
            comboBox1.Items.Add("Elastic");
            comboBox1.Items.Add("Exponential");
            comboBox1.Items.Add("Sine");

            comboBox1.SelectedIndex = 0;
        }
    }
}
